//CAMERABLUEFOX.dll
#include "HalconCpp.h"


//Variables globales______________________
long m_lFGHandle;
//Hobject image;
//Camra mvBlueFox
float m_fGain;
short m_iShutter;
long m_iL,m_iH;
//________________________________________
//Prototypes -> Voir bk.def
short INIT_CAMERA(void);
short LIT_IMAGE(long *m_R);
void QUITTE(void);
void REGLAGE_CAMERA(float m_fGain,short m_iShutter);
short LIT_IMAGE_ET_DIMENSIONNE(short L1,short H1,long *m_R);
//________________________________________
short INIT_CAMERA(void)
{
	short err;
	set_check("~give_error");
	close_all_framegrabbers();

	m_fGain=15.0f;
	m_iShutter=20000;
	m_iL=1280;   m_iH=1024;

  err=open_framegrabber("MatrixVisionAcquire",1,1,0,0,0,0,"default",-1,"default",m_fGain,"false","mvBlueFOX*","0",0,-1,&m_lFGHandle);
	if (err==2)
	{
		set_framegrabber_param(m_lFGHandle,HTuple("ImageHeight"),m_iH);
		set_framegrabber_param(m_lFGHandle,HTuple("ImageWidth"),m_iL);
		set_framegrabber_param(m_lFGHandle,"Camera/Expose_us",m_iShutter);
	}
	return err;
}
//________________________________________
short LIT_IMAGE(long *m_R)
{
	//Halcon
	Hobject image;
	char lpcsType[128];
	unsigned char *wR; 
	short err;
	long p,L,H;
	err=grab_image(&image,m_lFGHandle);

	get_image_pointer1(image,(long*)&wR,lpcsType,&L,&H);
	for (p=0;p<L*H;p++)	m_R[p]=*(wR+p);

	return err;
}
//________________________________________
void QUITTE(void)
{
	close_all_framegrabbers();
	set_check("give_error");
}
//________________________________________
void REGLAGE_CAMERA(float m_fGain,short m_iShutter)
{
	set_framegrabber_param(m_lFGHandle,"Camera/Expose_us",m_iShutter);
	set_framegrabber_param(m_lFGHandle,"Camera/Gain_dB",m_fGain);
}
//________________________________________
short LIT_IMAGE_ET_DIMENSIONNE(short L1,short H1,long *m_R)
{
	Hobject image,image1;
	char lpcsType[128];
	unsigned char *wR; 
	short err;
	long p,L,H;
	err=grab_image(&image,m_lFGHandle);

	zoom_image_size(image,&image1,L1,H1,"constant");

	get_image_pointer1(image1,(long*)&wR,lpcsType,&L,&H);
	for (p=0;p<L*H;p++)	m_R[p]=*(wR+p);

	return err;
}
